#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include "bergenListener.h"
#include "bergenServer.h"

int bergenListener::NextHandle = 1;


// PhysicalListener Constructor sets the initial position to 0,0,0 sets the
// killed flag ,increases the handle counter and creates an appropiate
// Physical Listener on the remote server 
bergenListener::bergenListener(class bergenServer *server)
	{
	server_ = server;
	handle_ = NextHandle++;
	killed_= 0;
	positionX_ = 0.0;
	positionY_ = 0.0;
	positionZ_ = 0.0;
	if(server_)
		createRemote();
	}	


// The bergen Listener destructor
bergenListener::~bergenListener(void)
	{	
	}	


// Parses the message and calls appropiate function
void bergenListener::message(char **msg,int numStrings)
	{
	if (!strcasecmp(msg[0],"setListenerPosition"))
		{
		if (numStrings > 3)
			setPosition(atof(msg[1]),atof(msg[2]),atof(msg[3]));
		}

	else if (!strcasecmp(msg[0],"killListener"))
		{
		kill();
		}
	else
		printf("listener %d got unrecognized message \"%s\"\n",handle_,msg[0]);
	}


// Creates it's representation on the remote server side 
void bergenListener::createRemote(void)
	{
	if (server_)
		{
		char message[256];
		sprintf(message,"-1 new listener");
		server_->sendMessage(message);
		handle_ = server_->receiveHandle();
		}
	else
		handle_ = 0;
	}


// Sets the bergen Listeners killed_ flag to mark it for remove 
void bergenListener::kill(void)
	{
	killed_ = 1;
	}


// Checks and returs the killed_ flag
int bergenListener::removable(void)
	{
	return killed_;
	}


// Kills it's representation on the remote server side 
void bergenListener::killRemote(void)
	{
	if (server_)
		{
		char message[256];
		sprintf(message,"%d killListener", handle_);
		server_->sendMessage(message);
		}
	}


// Sets the listener position to the new given position
void bergenListener::setPosition(float x, float y, float z)
	{
	if (server_)
		{
		char message[256];
		sprintf(message,"%d setListenerPosition %f %f %f", handle_,x,y,z);
		server_->sendMessage(message);
		}
	positionX_ = x;
	positionY_ = y;
	positionZ_ = z;
	}
