/******************************************************************************
 * Spatialized Sound Server                                                   *
 * bergenListener class - Headerfile                                        *
 *                                                                            *
 * Copyright 2002 Severin S. Todt - University of Applied Sciences Wedel      *
 *                s.todt@fh-wedel.de                                          *
 *                                                                            *
 * The Spatialized Sound Server in current release is based on the            *
 * Bergen Sound Server, edited 2000 by Dave Pape                              *
 *                                                                            *
 * The Spatilised Sound Server is developed within a project at the           *
 * Electronic Visualization Laboratory at the University of Illinois at       *
 * Chicago (www.evl.uic.edu) and is part of the master thesis written by      *
 * Severin S. Todt at the University of Applied Sciences - Wedel.             *
 * (www.fh-wedel.de)                                                          *
 *                                                                            *
 ******************************************************************************
 * Modification history :                                                     *
 * - Initial set-up                                                           *
 *                                                                            *
 *                                                   last modified : 08/19/02 *
 ******************************************************************************/
#ifndef _BERGEN_LISTENER_h_
#define _BERGEN_LISTENER_h_


class bergenListener
		{
		public:
		 bergenListener(class bergenServer *server);
		 ~bergenListener(void);
		 virtual void setPosition(float x, float y, float z);
		 inline int handle(void) const { return handle_; }
		 inline class bergenServer* server(void) const { return server_; }
		 inline float positionX(void) { return positionX_; };
		 inline float positionY(void) { return positionY_; };
		 inline float positionZ(void) { return positionZ_; };
		 virtual void message(char **msg,int num);
		 virtual void kill(void);
		 virtual void createRemote(void);	/* This should only be called by bergenServer */
		 virtual void killRemote(void);	/* This should only be called by bergenServer */
		 virtual int removable(void);
		protected:
		 static int NextHandle;
		 int handle_; 
		 float positionX_;
		 float positionY_;
		 float positionZ_;
		 class bergenServer* server_;
		 int killed_;
		};

#endif
