#ifndef _bergenSound_h_
#define _bergenSound_h_

enum AttenuationType {NONE,
			LINEAR_FALLOFF, 
			INVERSE_SQUARE_LAW,
			LINEAR_FALLOFF_FACTOR,
			INVERSE_SQUARE_FACTOR, 
			INVERSE_SQUARE_CLAMPED};

class bergenSound
		{
		public:
		 bergenSound(class bergenServer *server);
		 ~bergenSound(void);
		 inline int handle(void) const { return handle_; }
		 inline class bergenServer* server(void) const { return server_; }
		 inline float positionX(void) { return positionX_; };
		 inline float positionY(void) { return positionY_; };
		 inline float positionZ(void) { return positionZ_; };
		 inline bool isPlaying(void) { return isPlaying_; };
		 virtual void message(char **msg,int numStrings);
		 virtual void setAmplitude(float amp);
		 virtual void setDistance(float dist);
		 virtual void play(void);
		 virtual void stop(void);
		 virtual void pause(void);
		 virtual void kill(void);
		 virtual void killRemote(void);	/* This should only be called by bergenServer */
		 virtual void createRemote(void);	/* This should only be called by bergenServer */
		 virtual void setPosition(float x, float y, float z);
		 virtual void setAttenuationType(AttenuationType type);
		 virtual AttenuationType attenuationType(void);
		 virtual void setMinGain(float gain);
		 virtual float minGain(void);
		 virtual void setMaxGain(float gain);
		 virtual float maxGain(void);
		 virtual void setReferenceDistance(float distance);
		 virtual float referenceDistance(void);
		 virtual void setFalloffDistance(float distance);
		 virtual float falloffDistance(void);
		 virtual void setFalloffFactor(float factor);
		 virtual float falloffFactor(void);
		protected:
		 class bergenServer * server_;
		 int handle_;
		 bool isPlaying_;
		 AttenuationType attenuationType_; 
		 float positionX_;
		 float positionY_;
		 float positionZ_;
		 float minGain_; 			/*if sound is never silent*/
		 float maxGain_; 			/*if inverse square not clamped attenuation*/
		 float referenceDistance_; 	/*size for clamped and linear, reference for inverse not clamped*/
		 float falloffDistance_; 	/*distance at which 0 gain is reached - only valid for linear by distance and inverse square clamped*/
		 float falloffFactor_; 		/*influencing attenuation*/
		private:
		 static int nextHandle_;
		};

#endif
