/******************************************************************************
 * Bergen Sound Server Spatialized Edition                                    *
 * SpatializedBergenTest Demo Application Sourcefile                          *
 *                                                                            *
 * Copyright 2002 Severin S. Todt - University of Applied Sciences Wedel      *
 *                s.todt@fh-wedel.de                                          *
 *                                                                            *
 * The Bergen Sound Server in current release is based on the                 *
 * Bergen Sound Server, edited 2000 by Dave Pape                              *
 *                                                                            *
 * The Bergen Sound Server is developed within a project at the               *
 * Electronic Visualization Laboratory at the University of Illinois at       *
 * Chicago (www.evl.uic.edu) and is part of the master thesis written by      *
 * Severin S. Todt at the University of Applied Sciences - Wedel.             *
 * (www.fh-wedel.de)                                                          *
 *                                                                            *
 ******************************************************************************
 * Modification history :                                                     *
 * - initial setup                                                            *
 *                                                                            *
 *                                                   last modified : 08/20/02 *
 ******************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "bergenServer.h"
#include "bergenListener.h"
#include "bergenTone.h"
#include "bergenWhiteNoise.h"


int main(int argc,char **argv)
	{
	int slepptime=3;
	
	bergenServer * server = new bergenServer;
	bergenTone * tone = new bergenTone(server);
	tone->setAmplitude(0.25);
	tone->setFrequency(200.0);
	tone->play();
//	tone->setPosition(0.0,0.0,0.0);
	printf("pos 0,0,0\n");
	sleep(slepptime);

	printf("RIGHT pos -1.0,0,0\n");
	server->listener()->setPosition(-3.0,0.0,0.0);
	sleep(slepptime);

	printf("RIGHT-FRONT pos -1.0,0,1.0\n");
	server->listener()->setPosition(-3.0,0.0,3.0);
	sleep(slepptime);

	printf("FRONT CENTER pos 0,0,1.0\n");
	server->listener()->setPosition(0.0,0.0,3.0);
	sleep(slepptime);

	printf("LEFT-FRONT pos 1.0,0,1.0\n");
	server->listener()->setPosition(3.0,0.0,3.0);
	sleep(slepptime);

	printf("LEFT pos 1.0,0,0\n");
	server->listener()->setPosition(3.0,0.0,0.0);
	sleep(slepptime);

	printf("LEFT-BACK pos 1.0,0,-1.0\n");
	server->listener()->setPosition(3.0,0.0,3.0);
	sleep(slepptime);

	printf("BACK CENTER pos 0,0,-1.0\n");
	server->listener()->setPosition(0.0,0.0,-3.0);
	sleep(slepptime);

	printf("RIGHT-BACK pos -1.0,0,-1.0\n");
	server->listener()->setPosition(-3.0,0.0,-3.0);
	sleep(slepptime);

/*	while(actpos<100.0){
		tone->setPosition(actpos,0.0,0.0);
		actpos+=factor;
	}
	sleep(2);
	tone->setPosition(2.0,0.0,0.0);
	sleep(2);
	tone->setPosition(4.0,0.0,0.0);
	sleep(2);
	tone->setPosition(8.0,0.0,0.0);
	sleep(2);
	tone->setPosition(16.0,0.0,0.0);
	sleep(2);
	tone->setPosition(32.0,0.0,0.0);
	sleep(2);
	tone->setPosition(64.0,0.0,0.0);
	sleep(2);
	tone->setPosition(128.0,0.0,0.0);
	sleep(2);
	tone->setFrequency(2000.0);
	sleep(1);
	tone->setFrequency(500.0);
	sleep(1);*/
	tone->kill();
	delete tone;
/*	bergenSound * sound = new bergenWhiteNoise(server);
	sound->setAmplitude(0.25);
	sound->play();
	sleep(3);
	delete sound;*/
	delete server;
	return 0;
	}
