#ifndef _ASound_h_
#define _ASound_h_

#include "snerdServer.h"
#include "Listener.h"
#include "ASound.h"

enum AttenuationType {NONE,
			LINEAR_FALLOFF,
			INVERSE_SQUARE_LAW,
			LINEAR_FALLOFF_FACTOR,
			INVERSE_SQUARE_FACTOR,
			INVERSE_SQUARE_CLAMPED};

class ASound
		{
		public:
		 ASound(snerdDB* database, int listener, ConfigInformation* config);
		 ~ASound(void);
		 virtual short* updateBuffer(void);
		 virtual int removable(void);
		 virtual int active(void);
		 inline int handle(void) { return handle_; };
		 inline short * buffer(void) { return buffer_; };
		 inline int bufferSize(void) { return bufferSize_; };
		 virtual void setAmplitude(float amp);
		 virtual void setDistance(float dist);
		 virtual float amplitude(void);
		 virtual void play(void);
		 virtual void stop(void);
		 virtual void pause(void);
		 virtual void kill(void);
		 virtual void message(char **msg,int num);
			 void updatePosition(void);
		 	 void setSampleRate(int rate);
		 	 void setPosition(float x, float y, float z);
			 void setAttenuationType(AttenuationType type);
			 float attenuatedGain(void);
			 float spatializedGain(int speakerIndex);
			 void setMinGain(float gain);
			 void setMaxGain(float gain);
			 void setReferenceDistance(float distance);
			 void setFalloffDistance(float distance);
			 void setFalloffFactor(float factor);
		protected:
		 short* buffer_;
		 int bufferSize_;
		 int handle_;
		 float amplitude_;
		 float reportedDist_;
		 float distance_;
		 bool givenDistance_;
		 int sampleRate_;
		 ConfigInformation* config_;
		 snerdDB* db_;		 
		 AttenuationType attenuationType_; 
		 int listenerHandle_;
		 float reportedX_;
		 float reportedY_;
		 float reportedZ_;
		 float positionX_;
		 float positionY_;
		 float positionZ_;
		 float minGain_;			/*if sound is never silent*/
		 float maxGain_;			/*if inverse square not clamped attenuation*/
		 float referenceDistance_;	/*size for clamped and linear, reference for inverse not clamped*/
		 float falloffDistance_;	/*distance at which 0 gain is reached - only valid for linear by distance and inverse square clamped*/	 
		 float falloffFactor_;		/*influencing attenuation*/
		private:
		 static int NextHandle;
		};

#endif
