#include <stdio.h>
#include <stdlib.h>
#include <dmedia/audio.h>
#include "AudioInterface.h"


int AudioInterface::outputRate_;
int AudioInterface::inputRate_;
ALport AudioInterface::outputPort_;
ALport AudioInterface::inputPort_;
int AudioInterface::outputChannels_;
int AudioInterface::inputChannels_;
int AudioInterface::inputBufferReady_ = 0;
int AudioInterface::inputReadError_ = 0;
int AudioInterface::bufferSize_ = 0;
short * AudioInterface::inputBuffer_ = NULL;


void AudioInterface::openOutputPort(int bufsize,int sampleRate,int channels)
	{
	outputChannels_ = channels;
	bufferSize_ = bufsize;
	outputRate_ = sampleRate;
	ALconfig config = ALnewconfig();
	ALsetchannels(config, channels);
	ALsetwidth(config, AL_SAMPLE_16);
	ALsetqueuesize(config,bufsize * channels);
	outputPort_ = ALopenport("snerd","w",config);
	if (!outputPort_)
		{
		perror("ALopenport:output");
		exit(-1);
		}
	long params[2];
	params[0] = AL_OUTPUT_RATE;
	params[1] = sampleRate;
	ALsetparams(AL_DEFAULT_DEVICE,params,2);

	int error=0;
	if (outputChannels_ == 4)
		{
		params[0] = AL_CHANNEL_MODE;
		params[1] = 4;
		error = ALsetparams(AL_DEFAULT_DEVICE, params, 2);
		if(error<0)
			{
			params[0] = AL_CHANNEL_MODE;
			params[1] = 2;
			ALsetparams(AL_DEFAULT_DEVICE, params, 2);
			}
		}
	else
		{
		params[0] = AL_CHANNEL_MODE;
		params[1] = 2;
		ALsetparams(AL_DEFAULT_DEVICE, params, 2);
		}
	}

void AudioInterface::openInputPort(int bufsize,int sampleRate,int channels)
	{
	inputChannels_ = channels;
	bufferSize_ = bufsize;
	inputRate_ = sampleRate;
	ALconfig config = ALnewconfig();
	ALsetchannels(config, channels);
	ALsetwidth(config, AL_SAMPLE_16);
	ALsetqueuesize(config,bufsize * channels);
	inputPort_ = ALopenport("snerd","r",config);
	if (!inputPort_)
		{
		perror("ALopenport:input");
		exit(-1);
		}
	long params[2];
	params[0] = AL_INPUT_RATE;
	params[1] = sampleRate;
	ALsetparams(AL_DEFAULT_DEVICE,params,2);
	}

int AudioInterface::writeOutputPort(void *buffer,size_t bufsize)
	{
	return ALwritesamps(outputPort_, buffer, bufsize);
	}

int AudioInterface::readInputPort(void *buffer,size_t bufsize)
	{
	if (!inputBuffer_)
		inputBuffer_ = (short *) malloc(bufferSize_ * sizeof(short));
	if (inputBufferReady_)
		{
		inputReadError_ = ALreadsamps(inputPort_, inputBuffer_, bufferSize_);
		inputBufferReady_ = 0;
		}
	short* bufferPtr = (short*)buffer;
	for (int i=0; i<bufsize; i++)
		bufferPtr[i] = inputBuffer_[i*inputChannels_];
	return inputReadError_;
	}

void AudioInterface::fillInputPort(void)
	{
	inputBufferReady_ = 1;
	}
