#ifndef _RecordFile_h_
#define _RecordFile_h_

#ifdef AUDIOFILE_LIBRARY

#ifdef __sgi
#include <dmedia/audiofile.h>
#include <dmedia/audio.h>
#else
/* Linux */
#include <audiofile.h>
#endif

#else
/* No SGI audiofile library */
typedef int AFfilehandle;
#define AF_NULL_FILEHANDLE 0
#define AF_SAMPFMT_TWOSCOMP 1
#define AF_SAMPFMT_UNSIGNED 2

#endif

#include "ASound.h"

class RecordFile : public ASound
	{
	public:
	 RecordFile(char *filename, snerdDB* sDB, int listener, ConfigInformation* config);
	 ~RecordFile(void);
	 virtual char * filename(void);
	 virtual void record(void);
	 virtual void play(void);
	 virtual void stop(void);
	 virtual void pause(void);
	 virtual void kill(void);
	 virtual short * updateBuffer(void);
	 virtual int removable(void);
	 virtual int active(void);
	 virtual void message(char **,int);
	private:
	 char *filename_;
	 AFfilesetup filesetup_; 
	 AFfilehandle afFile_;
	 int recording_;
	 int killed_;
	 int channels_;
	 int bytesPerSample_;
	 int  fileRate_;
	 short * inputBuf_;
	 void initializeAFFile(void);
	};

#endif
